%global service cinder

%global common_desc \
Cinder is the OpenStack Block storage service. This is a spin out of nova-volumes.

Summary:          OpenStack Volume service
Name:             openstack-%{service}
Version:          21.3.1
Release:          3%{?dist}
License:          ASL 2.0
URL:              http://www.openstack.org/software/openstack-storage/
Source0:          https://tarballs.openstack.org/%{service}/%{service}-%{version}.tar.gz
Source1:          %{service}-sudoers
Source2:          %{service}.logrotate
Source3:          openstack-%{service}-api.service
Source4:          openstack-%{service}-scheduler.service
Source5:          openstack-%{service}-volume.service
Source6:          openstack-%{service}-backup.service

#upstream:https://launchpadlibrarian.net/722754200/cinder.patch
Patch0001:        fix-CVE-2024-32498.patch

BuildArch:        noarch

BuildRequires:    python3-pbr python3-jsonschema python3-castellan
BuildRequires:    python3-cursive python3-routes python3-webob
BuildRequires:    python3-barbicanclient python3-glanceclient python3-keystoneclient
BuildRequires:    python3-novaclient python3-swiftclient python3-google-api-client python3-oauth2client
BuildRequires:    python3-keystonemiddleware python3-keystoneauth1
BuildRequires:    python3-osprofiler python3-oslo-middleware python3-oslo-messaging python3-oslo-policy python3-oslo-reports python3-oslo-vmware
BuildRequires:    python3-packaging python3-paste python3-paste-deploy
BuildRequires:    python3-paramiko python3-eventlet python3-greenlet
BuildRequires:    python3-iso8601 python3-stevedore python3-tooz
BuildRequires:    python3-sqlalchemy python3-six python3-psutil
BuildRequires:    python3-os-brick python3-oslo-config python3-oslo-concurrency
BuildRequires:    python3-oslo-context python3-oslo-db python3-oslo-i18n
BuildRequires:    python3-oslo-log python3-oslo-privsep python3-oslo-rootwrap
BuildRequires:    python3-oslo-serialization python3-oslo-service python3-oslo-utils
BuildRequires:    python3-oslo-versionedobjects python3-oslo-upgradecheck
BuildRequires:    python3-taskflow python3-requests python3-pyparsing python3-pytz python3-tabulate
BuildRequires:    python3-cryptography python3-lxml python3-httplib2 python3-tenacity python3-decorator
BuildRequires:    python3-rtslib python3-zstd python3-importlib-metadata python3-boto3

BuildRequires:    python3-hacking python3-flake8-import-order python3-flake8-logging-format
BuildRequires:    python3-coverage python3-PyMySQL python3-psycopg2 python3-SQLAlchemy-Utils
BuildRequires:    python3-ddt python3-fixtures systemd
BuildRequires:    python3-oslotest python3-testtools python3-stestr
BuildRequires:    python3-bandit python3-doc8 python3-mypy python3-moto

Requires(pre):    shadow-utils
Requires:         python3-cinderclient python3-pyudev
Requires:         openstack-%{service}-api = %{version}-%{release} openstack-%{service}-scheduler = %{version}-%{release}
Requires:         openstack-%{service}-volume = %{version}-%{release} openstack-%{service}-backup = %{version}-%{release}

%description
%{common_desc}

%package common
Summary:          OpenStack Volume service (Cinder) - Common
Requires:         python3-cinder = %{version}-%{release}

%description common
%{common_desc}
This package contains scripts, config and dependencies shared between all the ${name} services

%package api
Summary:          OpenStack Volume service (Cinder) - API
Requires:         %{name}-common = %{version}-%{release}

%description api
%{common_desc}
This package contains the %{name} API server.

%package scheduler
Summary:          OpenStack Volume service (Cinder) - Scheduler
Requires:         %{name}-common = %{version}-%{release}

%description scheduler
%{common_desc}
This package contains the %{name} Scheduler server.

%package volume
Summary:          OpenStack Volume service (Cinder) - Volume
Requires:         %{name}-common = %{version}-%{release}

%description volume
%{common_desc}
This package contains the %{name} Volume server.

%package backup
Summary:          OpenStack Volume service (Cinder) - Backup
Requires:         %{name}-common = %{version}-%{release}
Requires:         targetcli

%description backup
%{common_desc}
This package contains the %{name} Backup server.


%package -n python3-%{service}
Summary:          OpenStack Volume Python libraries

Requires:         python3-pbr python3-jsonschema python3-castellan
Requires:         python3-cursive python3-routes python3-webob
Requires:         python3-barbicanclient python3-glanceclient python3-keystoneclient
Requires:         python3-novaclient python3-swiftclient python3-google-api-client
Requires:         python3-keystonemiddleware python3-keystoneauth1 python3-osprofiler
Requires:         python3-oslo-middleware python3-oslo-messaging python3-oslo-policy
Requires:         python3-oslo-vmware python3-oslo-upgradecheck python3-oslo-reports
Requires:         python3-oauth2client python3-packaging python3-paste python3-paste-deploy
Requires:         python3-paramiko python3-eventlet python3-greenlet
Requires:         python3-iso8601 python3-stevedore python3-tooz python3-sqlalchemy
Requires:         python3-six python3-psutil python3-os-brick
Requires:         python3-oslo-config python3-oslo-concurrency python3-oslo-context python3-oslo-db
Requires:         python3-oslo-i18n python3-oslo-log python3-oslo-privsep python3-oslo-rootwrap
Requires:         python3-oslo-serialization python3-oslo-service python3-oslo-utils python3-oslo-versionedobjects
Requires:         python3-taskflow python3-requests python3-pyparsing python3-pytz python3-tabulate
Requires:         python3-cryptography python3-lxml python3-httplib2 python3-tenacity python3-decorator python3-rtslib
Requires:         lvm2 sudo sysfsutils cryptsetup cracklib-dicts qemu-img iscsi-initiator-utils
Requires:         python3-zstd python3-importlib-metadata python3-boto3

%description -n python3-%{service}
%{common_desc}
This package contains the %{service} Python library.

%package -n python3-%{service}-tests
Summary:        Cinder tests

Requires:       python3-hacking python3-flake8-import-order python3-flake8-logging-format
Requires:       python3-coverage python3-PyMySQL python3-psycopg2 python3-SQLAlchemy-Utils
Requires:       python3-ddt python3-fixtures python3-oslotest python3-subunit
Requires:       python3-testtools python3-stestr  python3-bandit
Requires:       python3-doc8 python3-mypy python3-moto python3-%{service}

%description -n python3-%{service}-tests
%{common_desc}
This package contains the Cinder test files.

%prep
%autosetup -n %{service}-%{version}
rm -rf *requirements.txt

%build
%{py3_build}
oslo-config-generator --config-file=tools/config/%{service}-config-generator.conf

%install
%{py3_install}
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/rootwrap.d
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/volumes
install -p -D -m 640 etc/%{service}/rootwrap.conf %{buildroot}%{_sysconfdir}/%{service}/rootwrap.conf
install -p -D -m 640 etc/%{service}/api-paste.ini %{buildroot}%{_sysconfdir}/%{service}/api-paste.ini
install -p -D -m 640 etc/%{service}/%{service}.conf.sample %{buildroot}%{_sysconfdir}/%{service}/%{service}.conf
install -p -D -m 640 etc/%{service}/resource_filters.json %{buildroot}%{_sysconfdir}/%{service}/resource_filters.json
install -p -D -m 440 %{SOURCE1} %{buildroot}%{_sysconfdir}/sudoers.d/%{service}
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-%{service}

install -d -m 755 %{buildroot}%{_datarootdir}
install -d -m 755 %{buildroot}%{_datarootdir}/%{service}
install -d -m 755 %{buildroot}%{_datarootdir}/%{service}/rootwrap/
install -p -D -m 640 etc/%{service}/rootwrap.d/* %{buildroot}%{_datarootdir}/%{service}/rootwrap/

install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}/tmp

install -d -m 755 %{buildroot}%{_localstatedir}/log/%{service}
install -d -m 755 %{buildroot}%{_localstatedir}/run/%{service}

install -p -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/openstack-%{service}-api.service
install -p -D -m 644 %{SOURCE4} %{buildroot}%{_unitdir}/openstack-%{service}-scheduler.service
install -p -D -m 644 %{SOURCE5} %{buildroot}%{_unitdir}/openstack-%{service}-volume.service
install -p -D -m 644 %{SOURCE6} %{buildroot}%{_unitdir}/openstack-%{service}-backup.service

rm -f %{buildroot}%{python3_sitelib}/%{service}/locale/*/LC_*/%{service}*po
rm -f %{buildroot}%{python3_sitelib}/%{service}/locale/*pot
mv %{buildroot}%{python3_sitelib}/%{service}/locale %{buildroot}%{_datarootdir}/locale
rm -rf %{buildroot}%{_prefix}/etc


%pre common
getent group cinder >/dev/null || { 
        groupadd -r cinder $oldg 
    } 
    getent passwd cinder >/dev/null || { 
        useradd -r -g cinder  -d /var/lib/cinder  -s /sbin/nologin -c "OpenStack cinder Daemon" cinder 
    } 
exit 0

%post volume
%systemd_post openstack-%{service}-volume
%preun volume
%systemd_preun openstack-%{service}-volume
%postun volume
%systemd_postun_with_restart openstack-%{service}-volume


%post api
%systemd_post openstack-%{service}-api
%preun api
%systemd_preun openstack-%{service}-api
%postun api
%systemd_postun_with_restart openstack-%{service}-api


%post scheduler
%systemd_post openstack-%{service}-scheduler
%preun scheduler
%systemd_preun openstack-%{service}-scheduler
%postun scheduler
%systemd_postun_with_restart openstack-%{service}-scheduler


%post backup
%systemd_post openstack-%{service}-backup
%preun backup
%systemd_preun openstack-%{service}-backup
%postun backup
%systemd_postun_with_restart openstack-%{service}-backup



%files
%license LICENSE
%doc README.rst

%files common
%license LICENSE
%dir %attr(0750, %{service}, %{service}) %{_sysconfdir}/%{service}
%dir %attr(0750, %{service}, %{service}) %{_sysconfdir}/%{service}/volumes
%attr(-, %{service}, %{service}) %{_sysconfdir}/%{service}/rootwrap.d/
%config(noreplace) %attr(0640, %{service}, %{service}) %{_sysconfdir}/%{service}/%{service}.conf
%config(noreplace) %attr(0640, %{service}, %{service}) %{_sysconfdir}/%{service}/api-paste.ini
%config(noreplace) %attr(0640, %{service}, %{service}) %{_sysconfdir}/%{service}/rootwrap.conf
%config(noreplace) %attr(0640, %{service}, %{service}) %{_sysconfdir}/%{service}/resource_filters.json

%dir %attr(0750, %{service}, %{service}) %{_localstatedir}/log/%{service}
%dir %attr(0750, %{service}, %{service}) %{_localstatedir}/run/%{service}
%dir %attr(0750, %{service}, %{service}) %{_sharedstatedir}/%{service}
%dir %attr(0750, %{service}, %{service}) %{_sharedstatedir}/%{service}/tmp

%attr(-, %{service}, %{service}) %{_datarootdir}/%{service}
%attr(0640, root, %{service}) %{_sysconfdir}/logrotate.d/openstack-%{service}
%attr(0440, root, root) %{_sysconfdir}/sudoers.d/%{service}

%{_bindir}/%{service}-*
%exclude %{_bindir}/%{service}-api
%exclude %{_bindir}/%{service}-scheduler
%exclude %{_bindir}/%{service}-volume
%exclude %{_bindir}/%{service}-backup

%files api
%license LICENSE
%{_bindir}/cinder-api
%{_bindir}/cinder-wsgi
%{_unitdir}/openstack-cinder-api.service

%files scheduler
%license LICENSE
%{_bindir}/cinder-scheduler
%{_unitdir}/openstack-cinder-scheduler.service

%files volume
%license LICENSE
%{_bindir}/cinder-volume
%{_unitdir}/openstack-cinder-volume.service

%files backup
%license LICENSE
%{_bindir}/cinder-backup
%{_unitdir}/openstack-cinder-backup.service

%files -n python3-%{service}
%license LICENSE
%{python3_sitelib}/%{service}
%{python3_sitelib}/%{service}-*.egg-info
%{_bindir}/%{service}-rtstool
%exclude %{python3_sitelib}/%{service}/tests

%files -n python3-%{service}-tests
%license LICENSE
%{python3_sitelib}/%{service}/tests

%changelog
* Thu Sep 19 2024 jackeyji <jackeyji@tencent.com> - 21.3.1-3
- [Type] security
- [DESC] fix CVE-2024-32498

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 21.3.1-2
- Rebuilt for loongarch release

* Thu Sep 28 2023 jackeyji <jackeyji@tencent.com> - 21.3.1-1
- upgrade to 21.3.1

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 18.1.0-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 18.1.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 19 2023 Feng Weiyao <wynnfeng@tencent.com> - 18.1.0-1
- initial build
